/*
 * tree.c
 */

#include <stdlib.h>
#include <math.h>
#include "fplot.h"

#define PI	3.141592653589793
#define DEFAULT 8

double dth = PI / 9.0, dl = 0.8;

void tree(int, double, double, int, int);
int size(int, int);

#ifdef OLD
int main(int argc, char **argv)
#else
int main()
#endif
{
        int deg, len=80, wid;

#ifdef OLD
	deg = (argc > 1) ? atoi(argv[1]) : DEFAULT;
#else
	deg = DEFAULT;
#endif

	openpl(); wid=size(deg, len); space(-(wid>>1), 0, wid>>1, wid); erase();

	move(0, 0); cont(0, len);
        tree(deg, (double)len, 0.0, 0, len);
	move( 50, 50); label("<< Tree >>\n");
	mkplot("tree.plot");
	closepl();
	return 0;
}

void tree(int deg, double len, double th, int x, int y)
{
	int dx,dy;

        if (deg > 0) {
           dx=len*sin(th-dth); dy=len*cos(th-dth);
           tree(deg-1, 0.8*len, th-dth, x+dx, y+dy);
           move(x, y); cont(x+dx, y+dy);
           dx=len*sin(th+dth); dy=len*cos(th+dth);
           tree(deg-1, 0.8*len, th+dth, x+dx, y+dy);
           move(x, y); cont(x+dx, y+dy);
        }
}

int size(int deg, int len)
{
	int i;
	double dx, dy,th, dd;

	dx = 0.0; th = 0.0; dd=1.0;
	for (i = 1; i <= deg; i++) {
	    if (fabs(th-dth-0.5*PI) < fabs(th+dth-0.5*PI))
		th -= dth;
	    else
		th += dth;
	    dx += dd*sin(th); dd *= dl;
	}
	dx *= len; dy = 1.0; dd = 1.0;
	for (i = 1; i <= (deg+1) / 2; i++) dy += dd *= dl*dl;
	dy *= len * (1.0 + dl * cos(dth));
        dd = (2 * dx > dy) ? 2 * dx : dy;

	return 10 * ceil(0.1 * dd);
}
