/*
 * fplot.h
 */

#ifndef FPLOT

/* to avoid reading again */
#define FPLOT

/* Fortran  plot 饤֥ꥣؿ */

void openpl_(void);
void closepl_(void);
void erase_(void);
void space_(int *, int *, int *, int *);
void line_(int *, int *, int *, int *);
void circle_(int *, int *, int *);
void arc_(int *, int *, int *, int *, int *, int *);
void move_(int *, int *);
void cont_(int *, int *);
void point_(int *, int *);
void label_(char *, int);
void linemod_(char *);

/* ******************************************************** *
*	C interface by floating point numbers
* ******************************************************** */

/* ɸ ()  ɺɸ (ư) */
double invcorx(int);
double invcory(int);

void fspace(double, double, double, double);
void fspace2(double, double, double, double);
void dspace(double, double, double, double);
void dspace2(double, double, double, double);
void fline(double, double, double, double);
void dline(double, double, double, double);
void fcircle(double, double, double);
void dcircle(double, double, double);
void farc(double, double, double, double, double, double);
void darc(double, double, double, double, double, double);
void fmove(double, double);
void dmove(double, double);
void fcont(double, double);
void dcont(double, double);
void fpoint(double, double);
void dpoint(double, double);

/* ******************************************************** *
 *	Fortran interface by floating point numbers (real*4)
 * ******************************************************** */

void fspace_(float *, float *, float *, float *);
void fline_(float *, float *, float *, float *);
void fcircle_(float *, float *, float *);
void farc_(float *, float *, float *, float *, float *, float *);
void fmove_(float *, float *);
void fcont_(float *, float *);
void fpoint_(float *, float *);

/* ******************************************************** *
 *	Fortran interface by floating point numbers (real*8)
 * ******************************************************** */

void dspace_(double *, double *, double *, double *);
void dline_(double *, double *, double *, double *);
void dcircle_(double *, double *, double *);
void darc_(double *, double *, double *, double *, double *, double *);
void dmove_(double *, double *);
void dcont_(double *, double *);
void dpoint_(double *, double *);

/******************************************************************
 *	Fortran interface (fspace2, dspace2)
 ******************************************************************/

void fspace2_(float *, float *, float *, float *);
void dspace2_(double *, double *, double *, double *);

/******************************************************************
 * ʰץޡ¸ʤ plot(3) Ȥϲδطʤ
 ******************************************************************/

void mark(int, int);
void mark_(int *, int *);
void fmark(double, double);
void fmark_(float *, float *);
void dmark_(double *, double *);

/*
 * mouse.c
 */

void fmouse(int *, int *, int *, double *, double *);
void fmouse_(int *, int *, int *, float *, float *);
void dmouse_(int *, int *, int *, double *, double *);

/*
 * XPlot.c
 */

void xor_(void);
void set_(void);
void xflush_(void);
void xsync_(void);

/*
 */

void openpl(void);
void closepl(void);
void space(short int, short int, short int, short int);
void erase(void);
void move(short int, short int);
void cont(short int, short int);
void line(short int, short int, short int, short int);
void point(short int, short int);
void circle(short int, short int, short int);
void arc(short int, short int, short int, short int, short int, short int);
void label(char *);
void linemod(char *);

void check_expose(void);
void check_expose_(void);
void chkexp_(void);
void redraw(void);
void redraw_(void);
void mouse(int *, int *, int *, int *, int *);
void mkplot_(char *, int);
void mkplot2_(char *, int *);
void mkplot(char *);
void mkplot2(char *, int);

/*
*/
void xflush(void);
void xsync(void);

#endif
