/* heat1d.c -- Ū (ˡ) Ǯ
 *    1Ʊ Dirichlet 
 *
 *   ʬȷ׻齬11 p237 Υץĥ
 C     ** IMPLICIT FINITE DIFFERENCE METHOD **
 C     **         FOR HEAT EQUATION         **
 C     nfunc : ؿֹ5δؿѰդƤ
 C     theta : Υѥ᡼
 C     N : ʬο
 C     t : 
 C     tau : ֤ι
 C     Tmax : ξ
 C     h : ֤ι
 C     AL,AD,AU : 
 C     u : DIMENSION FOR UNKNOWN FUNCTION                     */

/*
 * ٤ĥ
 *   1) ֤κüüκɸѿ a, b ꤹ褦ˤ
 *   2) դȤˡޤǤդõ뤫ɤ
 *      ѿ erase_always 椹褦ˤ
 *   3) ׻ͥǡɽ뤫ѿ print_always 椹褦
 *      ˤ
 *   4) ƥåפ˥դ뤫ͥǡɽ뤫
 *      ѿ skips 椹褦ˤskips == 1 ȡ󥰥դ
 *      񤭴롣
 *   5) Ϳؿ f(x, nfunc) ǡϿƤؿμ
 *      䤷nfunc == 5 ޤǤ롣ä nfunc == 4,5 оΤ
 *      ؿǤ롣
 *
 */

#include <stdio.h>
#include <math.h>
#include "fplot.h"

#define	ndim	1000

/* ߼Ψ (math.h ˤ M_PI ͤѤ
 * 뤤 double PI; Ȥơɤ PI = 4.0 * atan(1.0); 
 */

#define	PI	M_PI

double f(double, int);
void print100(int, double, double *);
void axis(double, double, double, double);
void fsymbol(double, double, char *);
void print_data(double, double, double, double,
	   int, double, int, double, double,
           double, double, double);
void save_picture(void);
void trid(int, double *, double *, double *, double *);
void trilu(int, double *, double *, double *);
void trisol(int, double *, double *, double *, double *);

int main()
{
    int N, nfunc, i, j, Jmax;
    double a, b, theta, h, Tmax, tau, c1, c2, c3, c4, lambda, t;
    double AL[ndim], AD[ndim], AU[ndim], ff[ndim], u[ndim + 1];
    double xleft, ybottom, xright, ytop;
    /* ƥåפ˥դ񤭴뤫 */
    int skips = 1;
    double dt;
    /* դä(0=No, 1=Yes) */
    int erase_always = 0;
    /* ͤɽ뤫?(0=No, 1=Yes) */
    int print_always = 0;

    /* ֤κüü */
    a = 0.0;
    b = 1.0;

    /*  */
    printf("ϤƲ : nfunc(1..5)="); scanf("%d", &nfunc);
    printf("ϤƲ : ="); scanf("%lf", &theta);
    printf("ϤƲ : N(<=%d)=", ndim); scanf("%d", &N);
    if (N <= 1 || N > ndim)
	return 0;
    printf("ϤƲ : ="); scanf("%lf", &lambda);

    h = (b - a) / N;
    tau = lambda * h * h;
    printf(" ֤ι= %g ˤʤޤ\n", tau);

    printf("ϤƲ : Tmax="); scanf("%lf", &Tmax);

    printf("ޤֳִ t  : "); scanf("%lf", &dt);
    skips = ceil(dt / tau);
    dt = skips * tau;
    printf("dt=%g\n", dt);

    /* η׻ */
    c1 = - theta * lambda;
    c2 = 1.0 + 2.0 * theta * lambda;
    c3 = 1.0 - 2.0 * (1.0 - theta) * lambda;
    c4 = (1.0 - theta) * lambda;
    for (i = 1; i < N; i++) {
	AL[i] = c1; AD[i] = c2; AU[i] = c1;
    }

    /* LU ʬ򤹤 */
    trilu(N-1, AL+1, AD+1, AU+1);

    /*  */
    for (i = 0; i <= N; i++)
	u[i] = f(a + i * h, nfunc);

    /*  (t=0) */
    /*  (Ǥϲ̤˿ͤɽ뤳)  Fortran  C 
       ʤۤʤΤǡľܤϽʤΤǡ
       print100 ȤؿˤޤȤ᤿ */
    t = 0.0;
    print100(N, t, u);

    /* եå̤ν -- ޤ̤ϰϤƤ */
    xleft  = a - (b - a) / 10;
    xright = b + (b - a) / 10;
    ybottom = - 0.1;
    ytop    = 1.1;

    /* fplot 饤֥ꥣθƤӽФ */
    openpl();
    fspace2(xleft, ybottom, xright, ytop);

    /* ѥ᡼ϥǡɽ */
    print_data(xleft, ybottom, xright, ytop,
	       nfunc, theta, N, lambda, tau, Tmax, t, dt);

    /*  u  t=0 ˤ륰դ */
    fmove(a, u[0]);
    for (i = 1; i <= N; i++)
	fcont(a + i * h, u[i]);
    xsync();

    Jmax = ceil(Tmax / tau);

    /* ֤׻ */
    for (j = 1; j <= Jmax; j++) {

        /* ϢΩ켡äƲ */
	for (i = 1; i < N; i++)
	    ff[i] = c3 * u[i] + c4 * (u[i - 1] + u[i + 1]);
	trisol(N-1, AL+1, AD+1, AU+1, ff+1);

	/* ᤿ͤ u[] ˼ */
	for (i = 1; i < N; i++)
	    u[i] = ff[i];
	u[0] = 0.0;
	u[N] = 0.0;

	/* η׻ */
	t = j * tau;

	if (j % skips == 0) {
            /* ͥǡɽ */
	    if (print_always)
	        print100(N, t, u);

	    /* Υդ */
	    if (erase_always) {
		/* ޤΤäѥ᡼ɽ */
		erase();
		print_data(xleft, ybottom, xright, ytop,
			   nfunc, theta, N, lambda, tau, Tmax, t, dt);
	    }
	    fmove(a, u[0]);
	    for (i = 1; i <= N; i++)
		fcont(a + i * h, u[i]);
	    xsync();
	}
    }

    save_picture();

    printf("λСɥޥǥåƲ\n");
    closepl();
    return 0;
}

/**********************************************************/

/* ͿؿʣϿֹ nfunc 򤹤롣 */

double f(double x, int nfunc)
{
    /* f(x)=max(x,1-x) */
    if (nfunc == 1) {
	if (x <= 0.5)
	    return x;
	else
	    return 1.0 - x;
    }
    /* f(x)=1 */ 
    else if (nfunc == 2)
	return 1.0;
    else if (nfunc == 3)
	return sin(PI * x);
    /* f(x)= Ѥʷ򤷤(by M.Sakaue) */
    else if (nfunc == 4) {
	if (x <= 0.1)
	    return 5 * x;
	else if (x <= 0.3)
	    return -2 * x + 0.7;
	else if (x <= 0.5)
	    return 4.5 * x - 1.25;
	else if (x <= 0.7)
	    return - x + 1.5;
	else if (x <= 0.9)
	    return x + 0.1;
	else
	    return -10 * x + 10.0;
    }
    /* ϤоΤʷ򤷤(by M.Sakaue) */
    else if (nfunc == 5) {
	if (x <= 0.2)
	    return -x + 0.8;
	else if (x <= 0.3)
	    return 4 * x - 0.2;
	else if (x <= 0.4)
	    return -4 * x + 2.2;
	else if (x <= 0.7)
	    return - x + 1.0;
	else if (x <= 0.8)
	    return 4 * x - 2.6;
	else
	    return -x + 1.5;
    }
    else
        return 0.0;
}

/**********************************************************/

/*  u[] (u[0],u[1],...,u[n]) 5 Ĥɽ롣 */

void print100(int N, double t, double *u)
{
    int i;
    printf("T= %12.4e\n", t);
    for (i = 0; i < 5; i++)
	printf("  I     u(i)    ");
    printf("\n");
    for (i = 0; i <= N; i++) {
	printf("%3d%12.4e ", i, u[i]);
	if (i % 5 == 4)
	    printf("\n");
    }
    printf("\n");
}

/**********************************************************/

/* ɥ˺ɸɽ */
void axis(double xleft, double ybottom, double xright, double ytop)
{
    linemod("dotted");
    fline(xleft, 0.0, xright, 0.0);
    fline(0.0, ybottom, 0.0, ytop);
    linemod("solid");
}

/* ɥΰ (x,y) ʸ s ɽ */
void fsymbol(double x, double y, char *s)
{
    fmove(x, y);
    label(s);
}

#define	X(x)	(xleft+(x)*(xright-xleft))
#define	Y(y)	(ybottom+(y)*(ytop-ybottom))

/* ѥ᡼򥦥ɥɽ */
void print_data(double xleft, double ybottom, double xright, double ytop,
	   int nfunc, double theta, int N, double lambda, double tau,
           double Tmax, double t, double dt)
{
    char message[80];

    axis(xleft, ybottom, xright, ytop);
    sprintf(message, "heat equation, u(0)=u(1)=0");
    fsymbol(X(0.2), Y(0.95), message);
    sprintf(message,
	    "nfunc=%d, theta=%g, N=%d, lambda=%g, tau=%g, Tmax=%g, dt=%g",
	     nfunc, theta, N, lambda, tau, Tmax, dt);
    fsymbol(X(0.2), Y(0.9), message);
    sprintf(message, "t = %g", t);
    if (t != 0.0)
        fsymbol(X(0.2), Y(0.85), message);
}

/* ߥɥɽƤޤե¸ */
void save_picture(void)
{
    char filename[200];
    printf("ޤ¸ե̾: ");
    scanf("%s", filename);
    mkplot(filename);
}

/*************************************************************
 *************************************************************
 *************************************************************/

/*
 *  гѹФ LU ʬ˴ŤϢΩ켡ε
 *
 *  (Gauss ξõˡѤƤ뤬ԥܥåȤϤƤʤΤǡ
 *   оιǤʤȷ̤ݾڤʤ)
 *
 *  n ̤οθĿ
 *  f ϺǽϢΩ켡αդΥ٥ȥ bǸϲ٥ȥ x
 *   ź 0 顣i.e. b[0],b[1],...,b[n-1] ˥ǡäƤ롣)
 *  id Ϸ󤬤Ǥ LU ʬ򤵤Ƥ뤫ɤɽ
 *    (LU ʬ򤹤ɬפˤ 0 ꤹ롣
 *     ɬפʤ 0 ʳǤդͤ OK)
 *
 *  AL, AD, AU Ϸ
 *     ʬ(lower part)
 *     гʬ(diagonal part)
 *     廰ʬ(upper part)
 *  Ĥޤ
 *
 *  AD[0] AU[0]   0   .................. 0
 *  AL[1] AD[1] AU[1]   0  ............. 0
 *    0   AL[2] AD[2] AU[2]  0 ......... 0
 *          ....................
 *                    AL[n-2] AD[n-2] AU[n-2]
 *                      0     AL[n-1] AD[n-1]
 *
 *   AL[0], AU[n-1] ϰ̣ʤȤա
 */

/* (󤬻гѤǤϢΩ켡Τ)
 *   
 *     n: ̤οθĿ
 *     al,ad,au: ϢΩ켡η
 *       (al: гβ¦ ad: г au: гξ¦)
 *        al[i] = A_{i,i-1}, ad[i] = A_{i,i}, au[i] = A_{i,i+1},
 *        al[0], au[n-1] ϰ̣ʤ)
 *        f: ϢΩ켡αդδΥ٥ȥ b
 *   
 *     al,ad,au: Ϥ LU ʬ򤷤
 *     f: ϢΩ켡β x
 *   ǽ
 *      call ȷ LU ʬ򤷤Τ֤Τǡ
 *     ʸƱ˴ؤϢΩ켡򤯤ˡ
 *     ֥롼 trisol Ȥ롣
 *   
 *     ԥܥåȤ򤷤ƤʤΤǡͤǤ
 *     ʤɤŬڤʾ郎ʤϷ̤ݾڤǤʤ
 */

/*  */
void trid(int n, double *al, double *ad, double *au, double *f)
{
  trilu(n,al,ad,au);
  trisol(n,al,ad,au,f);
}

/* гѹ LU ʬ (pivoting ʤ) */
void trilu(int n, double *al, double *ad, double *au)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) ad[i + 1] -= au[i] * al[i + 1] / ad[i];
}

/* LU ʬѤߤλгѹ򷸿˻Ļ */
void trisol(int n, double *al, double *ad, double *au, double *f)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) f[i + 1] -= f[i] * al[i + 1] / ad[i];
  /*  (backward substitution) */
  f[nm1] /= ad[nm1];
  for (i = n - 2; i >= 0; i--) f[i] = (f[i] - au[i] * f[i + 1]) / ad[i];
}
